import {
    createDefaultModule, createDefaultSharedModule, DefaultSharedModuleContext, inject,
    LangiumServices, LangiumSharedServices, Module, PartialLangiumServices
} from 'langium';
import { CustomScopeComputation } from './kashmir-scope';
import { KashmirGeneratedModule, KashmirGeneratedSharedModule } from './generated/module';
import { KashmirValidator, registerValidationChecks } from './kashmir-validator';

/**
 * Declaration of custom services - add your own service classes here.
 */
export type KashmirAddedServices = {
    validation: {
        KashmirValidator: KashmirValidator
    }
}

/**
 * Union of Langium default services and your custom services - use this as constructor parameter
 * of custom service classes.
 */
export type KashmirServices = LangiumServices & KashmirAddedServices

/**
 * Dependency injection module that overrides Langium default services and contributes the
 * declared custom services. The Langium defaults can be partially specified to override only
 * selected services, while the custom services must be fully specified.
 */
export const KashmirModule: Module<KashmirServices, PartialLangiumServices & KashmirAddedServices> = {
    references:{
        ScopeComputation: (services) => new CustomScopeComputation(services)
    },    
    validation: {
        KashmirValidator: () => new KashmirValidator()
    }
};

/**
 * Create the full set of services required by Langium.
 *
 * First inject the shared services by merging two modules:
 *  - Langium default shared services
 *  - Services generated by langium-cli
 *
 * Then inject the language-specific services by merging three modules:
 *  - Langium default language-specific services
 *  - Services generated by langium-cli
 *  - Services specified in this file
 *
 * @param context Optional module context with the LSP connection
 * @returns An object wrapping the shared services and the language-specific services
 */
export function createKashmirServices(context: DefaultSharedModuleContext): {
    shared: LangiumSharedServices,
    Kashmir: KashmirServices
} {
    const shared = inject(
        createDefaultSharedModule(context),
        KashmirGeneratedSharedModule
    );
    const Kashmir = inject(
        createDefaultModule({ shared }),
        KashmirGeneratedModule,
        KashmirModule
    );
    shared.ServiceRegistry.register(Kashmir);
    registerValidationChecks(Kashmir);
    return { shared, Kashmir };
}
